/* $Id: Callback.h,v 1.2 1996/12/29 17:44:55 pgw Exp $ */
/*
 Copyright (C) 1996 Gerald L. Gay
 Copyright (C) 1996 Peter Williams

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave,
 Cambridge, MA 02139, USA.
*/

#if !defined(_XARM_CALLBACK_H_)
#define _XARM_CALLBACK_H_

/* ======================================================================= */
/* Include(s): */
#include <Xarm/CallbackP.h>

template<class T>
void addCallback(T *obj, 
                 void (T::*func) (Widget, XtPointer, XtPointer),
                 Widget w, 
                 _XtString type, 
                 XtPointer closure=NULL)
   {
      CallbackInfo<T> *ci = new CallbackInfo<T>;

      ci->_target=obj;
      ci->_widget=w;
      ci->_type=type;
      ci->_callback=func;
      ci->_closure=closure;

      registerCallback(ci);
   }

template<class T>
void removeCallback(T *obj, 
                       void (T::*func) (Widget, XtPointer, XtPointer),
                       Widget w, 
                       _XtString type, 
                       XtPointer closure=NULL)
   {
      CallbackInfo<T> ci, *pci;

      pci=&ci;
      pci->_target=obj;
      pci->_widget=w;
      pci->_type=type;
      pci->_callback=func;
      pci->_closure=closure;

      unregisterCallback(pci);
   }

template<class T>
void removeAllCallbacks(T *obj,
                        Widget w, 
                        _XtString type) 
   {
      CallbackInfo<T> ci, *pci;

      pci= &ci;
      pci->_target=obj;
      pci->_widget=w;
      pci->_type=type;
      pci->_callback=(void (T::*)(Widget, XtPointer, XtPointer)) NULL;
      pci->_closure=NULL;

      unregisterAllCallbacks(pci);
   }

#endif
